/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: getDoubleArrayOperationDispatcher.hxx
    Module  : extensionframework

    This is the root interface class of the getDoubleArrayOperationDispatcher. It contains of all the generic methods
    for getDoubleArrayOperationDispatcher that can be reused by the derived classes.

====================================================================================================
   Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef getDoubleArrayOperationDispatcher_HXX
#define getDoubleArrayOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class getDoubleArrayOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::getDoubleArrayOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
    public:
        getDoubleArrayOperationDispatcher();
        virtual ~getDoubleArrayOperationDispatcher();
        static OperationDispatcher *constructor();

        void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
        void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

        void getDoubleArrayPreConditions( const Teamcenter::BusinessObject* obj, std::vector<double>& doubleValues, std::vector<int>& isNullValues ) const;
        void getDoubleArrayPreActions( const Teamcenter::BusinessObject* obj, std::vector<double>& doubleValues, std::vector<int>& isNullValues ) const;
        void getDoubleArrayBaseAction( const Teamcenter::BusinessObject* obj, std::vector<double>& doubleValues, std::vector<int>& isNullValues ) const;
        void getDoubleArrayPostActions( const Teamcenter::BusinessObject* obj, std::vector<double>& doubleValues, std::vector<int>& isNullValues ) const;

        // Project 011450 changes
        void getDoubleArrayPreConditions( METHOD_message_t*  msgData, int* num, double** value, logical** isNull ) const;
        void getDoubleArrayPreActions( METHOD_message_t*  msgData, int* num, double** value, logical** isNull ) const;
        void getDoubleArrayBaseAction( METHOD_message_t*  msgData, int* num, double** value, logical** isNull ) const;
        void getDoubleArrayPostActions( METHOD_message_t*  msgData, int* num, double** value, logical** isNull ) const;

        void getDoubleArray( const Teamcenter::BusinessObject* obj, std::vector<double>& doubleValues, std::vector<int>& isNullValues ) const;

        void execute( Teamcenter::BusinessObject* obj,  std::vector<void*>&  args ) const;
        void execute( tag_t objTag, va_list  args ) const;
        void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


        //Fix compiler warnings that were hiding virtual functions
        using Teamcenter::OperationDispatcher::executePreConditions;
        using Teamcenter::OperationDispatcher::executePreActions;
        using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //getDoubleArrayOperationDispatcher_HXX
